      SUBROUTINE cv_diag_cin(nloc,ncum,nd,icb,inb
     :                      ,pbase,plcl,p,ph,tv,tvp,buoy
     o                      ,cape,cin,plfc)

*
***************************************************************
*                                                             *
* CV3P1_CLOSURE                                               *
*                  Ale & Alp Closure of Convect3              *
*                                                             *
* written by   :   Kerry Emanuel                              *
* vectorization:   S. Bony                                    *
* modified by :    Jean-Yves Grandpeix, 18/06/2003, 19.32.10  *
*                  Julie Frohwirth,     14/10/2005  17.44.22  *
***************************************************************
*
      implicit none

#include "cvthermo.h"
#include "cv3param.h"
#include "YOMCST2.h"
#include "YOMCST.h"

c input:
      integer ncum, nd, nloc
      integer icb(nloc), inb(nloc)
      real pbase(nloc),plcl(nloc)
      real p(nloc,nd), ph(nloc,nd+1)
      real tv(nloc,nd),tvp(nloc,nd), buoy(nloc,nd)
c output:
      real cape(nloc),cin(nloc)
      real plfc(nloc)
c
c local variables:
      integer il, i, j, k
      real deltap,deltap_c
      real cina(nloc),cinb(nloc)
c
      i=nloc/2
      print *,' -> cv_diag_cin, plcl ',plcl(i)
c
c
c -------------------------------------------------------------
c -- Calculate convective inhibition (CIN)
c -------------------------------------------------------------
      CALL cv3_cine (nloc,ncum,nd,icb,inb
     :                      ,pbase,plcl,p,ph,tv,tvp
     :                      ,cina,cinb,plfc)
c
      DO il = 1,ncum
        cin(il) = cina(il)+cinb(il)
      ENDDO
c
c -------------------------------------------------------------
c -- Calculate convective available potential energy (cape),
c -------------------------------------------------------------

      do 500 il=1,ncum
       cape(il)=0.0
 500  continue
c
c

      do 600 k=1,nd-1
      
       do 610 il=1,ncum

        if ((k.ge.(icb(il)+1)).and.(k.le.inb(il))) then

         deltap = ph(il,k-1)-ph(il,k)
c the interval on which cape is computed starts at pbase :
         deltap_c = MIN(pbase(il),ph(il,k-1))-MIN(pbase(il),ph(il,k))
         cape(il)=cape(il)+rrd*buoy(il,k-1)*deltap_c/p(il,k-1)
         cape(il)=AMAX1(0.0,cape(il))
        endif

 610   continue
 600  continue
c
       return
       end


