!#########################################"

       SUBROUTINE m_undilute3(itap,mlon,kmb,mlev,slope
     :                       ,m_icb,m_icbs,nk
     :                       ,m_w_lcl,tnk,qnk,gznk,hnk
     :                       ,t,q,qs,gz,p,h,tv,lv
     :                       ,m_plcl
     o                       ,m_t,m_tv,m_buoy,m_w,dzh_2)
      USE dimphy
      implicit none

!---------------------------------------------------------------------
!      Jean-Yves GRANDPAIX
!      modifi par YU Jingmei pour m_breeze 
!---------------------------------------------------------------------
!MB: remplacer nl en klev
!    m_icb(i) = m_icbs(i)+1
!    nk(i) = m_icbs(i)
!-----------------------------------------
!---------------------------------------------------------------------
*KEEP,YOMCST.
#include "YOMCST.h" 
#include "cvthermo.h"
#include "cv3param.h"
#include "conema3.h"

c inputs:
      integer iq,mlon,kmb(klon),itap
      integer m_icb(klon), m_icbs(klon), nk(klon), mlev(klon)
      real slope(klon)
      real t(klon,klev), q(klon,klev), qs(klon,klev), gz(klon,klev)
      real p(klon,klev),lv(klon,klev), tv(klon,klev), h(klon,klev)
      real tnk(klon), qnk(klon), gznk(klon),hnk(klon)
      real m_plcl(klon),m_w_lcl(klon)
      real m_w(klon,klev),dzh_2(klon,klev)

c outputs:
      real m_t(klon,klev), m_tv(klon,klev), m_buoy(klon,klev)

c local variables:
      integer i, k
      real tg,qg,ahg,alv,s,tc,es,denom,rrg,tca,elacrit
      real by, defrac, pden
      real ah0(klon), cape(klon), capem(klon), byp(klon)
      logical lcape(klon)
      integer iposit(klon)
      real e_poten,kaka
      real ep(klon,klev)
!=====================================================================
! --- INITIALIZATIONS
!=====================================================================

 
       do 170 k=1,klev
       do 160 iq=1,mlon
             i=kmb(iq)
             ep(i,k)=0.0
             ah0(i)=0.
             iposit(i) =0
 160  continue
 170  continue

             ptcrit=500.0
             pbcrit=150.0

!=====================================================================
! --- FIND THE REST OF THE LIFTED PARCEL TEMPERATURES
!=====================================================================
c
c ---       The procedure is to solve the equation.
c              cp*m_t+L*qp+phi=cp*tnk+L*qnk+gznk.
c
c   ***  Calculate certain quantities, including static energy   ***
c
c
      do 240 iq=1,mlon
              i=kmb(iq)
         if (m_w_lcl(i).gt.0.) then
             ah0(i)=(cpd*(1.-qnk(i))+cl*qnk(i))*tnk(i)
     &         +qnk(i)*(lv0-clmcpv*(tnk(i)-273.15))+gznk(i)
         endif!  if (m_w_lcl(i).gt.0.) 
 240  continue
c
c
c    ***  First lifted parcel quantities above cloud base    ***

 	do 300 k=1,klev
	  do 290 iq=1,mlon
                   i=kmb(iq)
            if (m_w_lcl(i).gt.0.) then
	     if(k.ge.m_icb(i)) then 
	       tg=t(i,k)
	       qg=qs(i,k)
	       alv=lv0-clmcpv*(t(i,k)-273.15)
               s=cpd*(1.-qnk(i))+cl*qnk(i)      
     :                +alv*alv*qg/(rrv*t(i,k)*t(i,k)) 
	       s=1./s
c 1)First iteration
               ahg=cpd*tg+(cl-cpd)*qnk(i)*tg+alv*qg+gz(i,k) 
	       tg=tg+s*(ah0(i)-ahg)
	       tc=tg-273.15
	       denom=243.5+tc
               denom=MAX(denom,1.0) 
               es=6.112*exp(17.67*tc/denom)
               qg=eps*es/(p(i,k)-es*(1.-eps))
!            print*,'first iteration pour tg et qg'
!            print*,'p',p
!            print*,'ahg',ahg,'es',es,'tc',tc,'tg',tg,'qg',qg,'s',s
c 2)Second iteration
c
               ahg=cpd*tg+(cl-cpd)*qnk(i)*tg+alv*qg+gz(i,k) 
	       tg=tg+s*(ah0(i)-ahg)
	       tc=tg-273.15
	       denom=243.5+tc
               denom=MAX(denom,1.0) 
               es=6.112*exp(17.67*tc/denom)
               qg=eps*es/(p(i,k)-es*(1.-eps))
! 3) m_t,m_tv
	       alv=lv0-clmcpv*(t(i,k)-273.15)
c      print*,'m_t(i,k),ah0(i),cl,cpd,qnk(i),t(i,k),gz(i,k),alv,qg,cpd'
c      print*,m_t(i,k),ah0(i),cl,cpd,qnk(i),t(i,k),gz(i,k),alv,qg,cpd
               m_t(i,k)=(ah0(i)-gz(i,k)-alv*qg)/(cpd+(cl-cpd)*qnk(i))
               m_tv(i,k)=m_t(i,k)*(1.+qg/eps-qnk(i)) 
!            print*,'secoklev iteration pour tg et qg'
!            print*,'ahg',ahg,'es',es,'tg',tg,'qg',qg,'s',s
!----------------------------------------------------
             endif  !(m_w_lcl(i).gt.0.) 
            endif!(k.ge.m_icb(i))
  290     continue
  300   continue
c
c=====================================================================
c  --- EFFECTIVE VERTICAL PROFILE OF BUOYANCY 
c=====================================================================

!-- m_buoy et m_w
!
!-- Si lcl est en-dessous du sommet le plus haut, il faut representer 
!  l'effet de la convergence qui rend la brise verticale.
      do  iq=1,mlon
                i=kmb(iq)
         if  ((m_icb(i)-1 .le. mlev(i)) .and.
     $        (m_w_lcl(i).gt.0.)             ) then
          m_w(i,m_icb(i)-1) = m_w(i,m_icb(i)-1)/sin(slope(i))
         endif
      enddo
!
      do  k=2,klev
       do  iq=1,mlon
                 i=kmb(iq)
         if  ((k.ge.m_icb(i)).and.(m_w_lcl(i).gt.0.)) then
          if (m_w(i,k-1).gt.0.)then
              m_buoy(i,k)=m_tv(i,k)-tv(i,k)
              e_poten= RG* 
     $           (m_buoy(i,k)+m_buoy(i,k-1))/(tv(i,k)+tv(i,k-1))
     $           *dzh_2(i,k)
              kaka=0.5*m_w(i,k-1)**2+e_poten
              if (kaka.gt.0.) then
                 m_w(i,k)=sqrt(2*kaka)
              else
                 m_w(i,k)=0.
              endif!(kaka.gt.0.)
           else 
                 m_w(i,k)=0.
                 m_buoy(i,k)=0.
           endif! (m_w(i,k-1).gt.0.)
         endif!   ((k.ge.m_icb(i)).and.(m_w_lcl(i).gt.0.))
        enddo
       enddo
!-- test
!      do k=1,klev
!       if (k.le.m_icbs(1))then
!        if ((m_w(i,k).ge.0.).and.(m_w(i,k).gt.0.)) then
!          print*,'1.5 m_w=0,m_w>0,k,m_icbs',m_w(1,k),k,m_icbs(1)
!        endif
!       endif
!      enddo
!

!-----------------------
!- remis m_t,m_tv a zero quand m_w=0.
          do  k=2,klev
           do  iq=1,mlon
                 i=kmb(iq)
            if (m_w(i,k).le.0.) then
                m_t(i,k)=t(i,k)
                m_tv(i,k)=tv(i,k)
            endif
           enddo
          enddo
!---------------------------
! --- test pour m_buoy
!       print*,'m_undilute3,m_buoy',m_buoy(100,1),
!     $          'm_tv',m_tv(100,1),'tv',tv(100,1)
!        print*,'hp',hp
!        print*,'m_buoy',m_buoy
!        print*,'alv',alv
!        print*,'ah0',ah0
!        print*,'gz',gz
!        print*,'eps',eps
!        print*,'qs',qs
!        print*,'tnk',tnk,'qnk',qnk,'hnk',hnk,'gznk',gznk
!        print*,'clw',clw
!        print*,'m_tv',m_tv,'m_t',m_t
!        print*,'m_buoy',m_buoy
!--- test pour t,q,qs,gz,p,h,tv,lv
!      print*,'dans m_uklevilute2,itap',itap
!      print*,'t,q,qs',t(100,1),q(100,1),qs(100,1)
!      print*,'gz,p,h',gz(100,1),p(100,1),h(100,1)
!      print*,'tv',tv(100,1)
!-- test
!           do k=1,klev-1
!              do iq=1,mlon
!                 i=kmb(iq)
!              if (m_w_lcl(i).gt.0.)then
!              if ((m_w(i,k).eq.0.).and.(m_w(i,k+1).gt.0.))then
!                    if (k.gt.m_icbs(i))then 
!              print*,'undilute,m_w=0,k>m_icbs,k,m_icbs', k, m_icbs(i)
!                    endif! (k.gt.m_icbs(i))
!              endif !((m_w(i,k).eq.0.).and.(m_w(i,k+1).gt.0.))
!              endif  
!            enddo
!           enddo
!---------------------------------------- 

        return
        end
        
